library(foreign)
library(tm.corpus.Reuters21578)
data(Reuters21578)
reuters <- Reuters21578

reuters <- tm_map(reuters, removeWords, stopwords("english"))

reuters <- tm_map(reuters, removeNumbers)
reuters <- tm_map(reuters, removePunctuation)
reuters <- tm_map(reuters, stripWhitespace)

set.seed(30)

sample_size=50
reuters_sample <- sample(tm_filter(reuters, function(x) length(x$meta$places) != 0 && length(strsplit(x$meta$places, " ")) == 1 && (x$meta$lewissplit == "TRAIN" || x$meta$lewissplit == "TEST")), sample_size)

# bag of words (s frekvenciami, mozu byt uzitocne)
bag <- TermDocumentMatrix(reuters_sample, control=list())
x=inspect(bag)

bag_transp <- t(bag)
x=inspect(bag_transp)
nr=nrow(x)

a=c()
#vytvori vektor places z meta pro vzorky
for(i in c(1:nr)){
  atr=reuters_sample[[i]]$meta$places
  if(length(atr)>0){
    #pokud je vzorek oznaceny, prida ho do vektoru
    a <- c(a, atr)
  }
  else{
    #N/A pro neoznacene vzorky
    a <- c(a, "N/A")
  }
}
#slouceni TermDocumentMatrix a vektoru places
x <- data.frame(x,a)

#.arff chce class atribut, pokud je class i jako term, prejmenuje ho na classX
names(x)[names(x)=="class"] <- "classX"

#zmena jmena posledniho sloupce na class
colnames(x)[ncol(x)]="class"

#zapis do .arff souboru
o_name="bag2"
arff_name=paste(o_name,"arff",sep=".")

write.arff(x, arff_name)

#run WEKA-CODB
out=system(paste("java -cp WEKA-CODB.jar motaz.CODB -t ",arff_name,sep=""), intern=TRUE)

#write output of WEKA-CODB to .out file
write(out, paste(o_name,"out",sep="."))

#print top num_out outliers (filter WEKA-CODB output)
position=pmatch("=== Top 10 COF ===",out)

num_out=3
i=0

while(i<num_out){
  #Instance number
  print(gsub(".*\\((.*)\\).*", "\\1", out[position+1]))
  
  #PCL, Deviation, KDist
  print(out[position+2])
  
  #---------
  print(out[position+3])
  
  i=i+1
  position=position+3
}
